# pixel-moo
Project using MOO to see how easily we can break an ML algorithm

# Setup
This project uses pip and pipenv, ensure you have pipenv installed.
```
pip install pipenv
```
In the main folder of the project run:
```
pipenv shell
pip install
```

---
There are a few changes, some older files here (index..*) contain the original algorithm for looping through and fuzzing our image.
The project now contains the file soo-ga.py, which is using Single Object Optimization and the Genetic Algorithm to fuzz our image through generations.

Currently set to 100 iterations, you will see an output of the different predictions along with a final image at the end of the run.

# Running
Locally, modify variables in execute_tests.py:
 * file
 * start
 * algorithm
 * module_type

This can also be run directly from the command line:
```
python execute_tests.py images_to_run/<file_name> 1 nsga2 vgg19
```

# Docker
First create the image for running tests in:
```
docker build --rm --tag pymoo:cuda-11-7-0-cudnn8 .
```

You can then run tests locally in the docker container:
```
docker run -d --name nsde-vgg19-<image_name> -u <uid> --gpus all -v <full_path>/moo-pixels:/code --entrypoint /bin/bash pymoo:cuda-11-7-0-cudnn8 -c "cd code && python3.10 execute_tests.py images_to_run/<file_name> 1 nsde vga19"
```