#! /bin/bash
algorithm=$1
modelType=$2

methods=( ga nsga2 )
models=( vgg16 vgg19 r50 r101 r152 )
for algorithm in "${methods[@]}"
do
  for modelType in "${models[@]}"
  do
    for file in images_to_run/*.JPEG; do
    file_name="$(echo $file | cut -d'/' -f2)"
    just_file="$(echo $file_name | cut -d'.' -f1)"
    echo $file
    echo $algorithm
    echo $modelType
      echo $(docker ps -f status=running | grep -o pymoo | wc -l)
      while [ $(docker ps -f status=running | grep -o pymoo | wc -l) -ge 8 ];
      do
        echo 'waiting for processes to finish'
        sleep 1200
      done
      docker run -d --name $algorithm-$modelType-$just_file -u 3005 --gpus all -v /home/abcd/moo-vgg19:/code --entrypoint /bin/bash pymoo:cuda-11-6-2-cudnn8 -c "cd code && python3.10 execute_tests.py $file 1 $algorithm $modelType"
      sleep 2
    done
  done
done

