from pymoo.core.sampling import Sampling
import numpy as np
import src.mutations as mutation


# InitialImageSampling - Generates our base samples. Uses the given image_array to generate a new seed.
# Modifies one pixel in this seed and adds it to our sample array along with the initial prediction value.
class InitialImageSampling(Sampling):

    def _do(self, problem, n_samples, **kwargs):
        samples = np.full((n_samples, 3), None, dtype=object)

        for i in range(n_samples):
            seed, matrix = mutation.add_gaussian_mutation(problem, [])
            values = problem.get_predictions(seed)
            fitness = values[0][2]
            samples[i, 0] = fitness
            samples[i, 1] = seed
            samples[i, 2] = matrix

        return samples
